<?xml version="1.0" encoding="ISO-8859-1"?>
<!--
Copyright (C) 2010  Paul Wolneykien <manowar@altlinux.org>

This file is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
-->
<xsl:stylesheet version="1.0"
	        xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:template name="add-unbinded-host">
  <xsl:text>insert into hosts(hostid, proxy_hostid, host, dns, useip, ip, status) </xsl:text>
  <xsl:text>select coalesce(max(hostid), 0) + 1 as hostid, </xsl:text>
  <xsl:text>0 as proxy_hostid, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="name" /><xsl:text>' as host, </xsl:text>
  <xsl:if test="ipaddr">
    <xsl:text>NULL as dns, </xsl:text>
    <xsl:text>1 as useip, </xsl:text>
    <xsl:text>'</xsl:text><xsl:value-of select="ipaddr" /><xsl:text>' as ip, </xsl:text>
  </xsl:if>
  <xsl:if test="hostname">
    <xsl:text>'</xsl:text><xsl:value-of select="hostname" /><xsl:text>' as dns, </xsl:text>
    <xsl:text>0 as useip, </xsl:text>
    <xsl:text>NULL as ip, </xsl:text>
  </xsl:if>
  <xsl:text>0 as status </xsl:text>
  <xsl:text>from hosts;
</xsl:text>
</xsl:template>
<xsl:template name="add-node">
  <xsl:param name="nodetype" />
  <xsl:param name="masterid" />
  <xsl:text>insert into nodes (nodeid, name, timezone, ip, nodetype, masterid) </xsl:text>
    <xsl:text>values (</xsl:text>
    <xsl:value-of select="id" /><xsl:text>, </xsl:text>
    <xsl:text>'</xsl:text><xsl:value-of select="name" /><xsl:text>', </xsl:text>
    <xsl:value-of select="timezone" /><xsl:text>, </xsl:text>
    <xsl:text>'</xsl:text><xsl:value-of select="ipaddr" /><xsl:text>', </xsl:text>
    <xsl:value-of select="$nodetype" /><xsl:text>, </xsl:text>
    <xsl:value-of select="$masterid" /><xsl:text>);
</xsl:text>
</xsl:template>
<xsl:template name="add-group">
  <xsl:param name="name" />
  <xsl:text>replace groups (groupid, name) </xsl:text>
  <xsl:text>select coalesce(</xsl:text>
  <xsl:text>(select groupid from groups </xsl:text>
  <xsl:text>where name = '</xsl:text>
  <xsl:value-of select="$name" />
  <xsl:text>'), </xsl:text>
  <xsl:text>max(groupid) + 1, 1) as groupid, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$name" /><xsl:text>' as name </xsl:text>
  <xsl:text>from groups;
</xsl:text>
</xsl:template>
<xsl:template name="bind-host-group">
  <xsl:param name="hostname" />
  <xsl:param name="groupname" />
  <xsl:text>insert into hosts_groups (hostgroupid, hostid, groupid) </xsl:text>
  <xsl:text>select coalesce(max(hostgroupid), 0) + 1 as hostgroupid, </xsl:text>
  <xsl:text>(select hostid from hosts where host = '</xsl:text>
  <xsl:value-of select="$hostname" /><xsl:text>') as hostid, </xsl:text>
  <xsl:text>(select groupid from groups where name = '</xsl:text>
  <xsl:value-of select="$groupname" /><xsl:text>') as groupid </xsl:text>
  <xsl:text>from hosts_groups;
</xsl:text>
</xsl:template>
<xsl:template name="place-host-on-map">
  <xsl:param name="map" />
  <xsl:param name="host" />
  <xsl:text>insert into sysmaps_elements </xsl:text>
  <xsl:text>select coalesce(max(me.selementid), 0) + 1 as selementid, </xsl:text>
  <xsl:text>m.sysmapid as sysmapid, </xsl:text>
  <xsl:text>h.hostid as elementid, </xsl:text>
  <xsl:text>0 as elementtype, </xsl:text>
  <xsl:text>i.imageid as iconid_on, </xsl:text>
  <xsl:text>0 as iconid_off, </xsl:text>
  <xsl:text>0 as iconid_unknown, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$host/name" /><xsl:text>' as label, </xsl:text>
  <xsl:text>NULL as label_location, </xsl:text>
  <xsl:value-of select="round(($host/pos/lon - $map/upper/lon) * ($map/width div ($map/lower/lon - $map/upper/lon)))" />
  <xsl:text> as x, </xsl:text>
  <xsl:value-of select="round(($map/upper/lat - $host/pos/lat) * ($map/height div ($map/upper/lat - $map/lower/lat)))" />
  <xsl:text> as y, </xsl:text>
  <xsl:text>'' as url, </xsl:text>
  <xsl:text>0 as iconid_disabled, </xsl:text>
  <xsl:text>0 as iconid_maintenance </xsl:text>
  <xsl:text>from sysmaps_elements me </xsl:text>
  <xsl:text>right join sysmaps m on 1 = 1 </xsl:text>
  <xsl:text>right join hosts h on 1 = 1 </xsl:text>
  <xsl:text>right join images i on 1 = 1 </xsl:text>
  <xsl:text>where m.name = '</xsl:text><xsl:value-of select="$map/../name" /><xsl:text>' </xsl:text>
  <xsl:text>and h.host = '</xsl:text><xsl:value-of select="$host/name" /><xsl:text>' </xsl:text>
  <xsl:text>and i.imagetype = 1 </xsl:text>
  <xsl:text>and i.name = 'Hub';
</xsl:text>
</xsl:template>
<xsl:template name="link-hosts-on-map">
  <xsl:param name="map" />
  <xsl:param name="host-1" />
  <xsl:param name="host-2" />
  <xsl:text>insert into sysmaps_links </xsl:text>
  <xsl:text>select coalesce(max(ml.linkid), 0) + 1 as linkid, </xsl:text>
  <xsl:text>m.sysmapid as sysmapid, </xsl:text>
  <xsl:text>me1.selementid as selementid1, </xsl:text>
  <xsl:text>me2.selementid as selementid2, </xsl:text>
  <xsl:value-of select="$link-drawtype" /><xsl:text> as drawtype, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$link-color" /><xsl:text>' as color, </xsl:text>
  <xsl:text>'' as label </xsl:text>
  <xsl:text>from sysmaps_links ml </xsl:text>
  <xsl:text>right join sysmaps m on 1 = 1 </xsl:text>
  <xsl:text>right join sysmaps_elements me1 on me1.sysmapid = m.sysmapid and me1.elementtype = 0 </xsl:text>
  <xsl:text>right join hosts h1 on me1.elementid = h1.hostid </xsl:text>
  <xsl:text>right join sysmaps_elements me2 on me2.sysmapid = m.sysmapid and me2.elementtype = 0 </xsl:text>
  <xsl:text>right join hosts h2 on me2.elementid = h2.hostid </xsl:text>
  <xsl:text>where m.name = '</xsl:text><xsl:value-of select="$map/../name" /><xsl:text>' </xsl:text>
  <xsl:text>and h1.host = '</xsl:text><xsl:value-of select="$host-1/name" /><xsl:text>' </xsl:text>
  <xsl:text>and h2.host = '</xsl:text><xsl:value-of select="$host-2/name" /><xsl:text>';
</xsl:text>
</xsl:template>
<xsl:template name="add-map">
  <xsl:param name="prefix" />
  <xsl:text>insert into images (imageid, imagetype, name, image) </xsl:text>
  <xsl:text>select coalesce(max(imageid), 0) + 1 as imageid, </xsl:text>
  <xsl:text>2 as imagetype, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="../name" /><xsl:text>', </xsl:text>
  <xsl:text>load_file('</xsl:text>
  <xsl:if test="$prefix != ''">
    <xsl:value-of select="$prefix" /><xsl:text>/</xsl:text>
  </xsl:if>
  <xsl:value-of select="image" /><xsl:text>') </xsl:text>
  <xsl:text>from images;
</xsl:text>
  <xsl:text>insert into sysmaps </xsl:text>
  <xsl:text>select coalesce(max(m.sysmapid), 0) + 1 as sysmapid, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="../name" /><xsl:text>' as name, </xsl:text>
  <xsl:value-of select="width" /><xsl:text> as width, </xsl:text>
  <xsl:value-of select="height" /><xsl:text> as height, </xsl:text>
  <xsl:text>i.imageid as backgroundid, </xsl:text>
  <xsl:text>0 as label_type, </xsl:text>
  <xsl:text>0 as label_location, </xsl:text>
  <xsl:text>21 as highlight </xsl:text>
  <xsl:text>from sysmaps m right join images i on 1 = 1 </xsl:text>
  <xsl:text>where i.imagetype = 2 </xsl:text>
  <xsl:text>and i.name = '</xsl:text><xsl:value-of select="../name" /><xsl:text>';
</xsl:text>
</xsl:template>
<xsl:template name="update-node">
  <xsl:text>update nodes set </xsl:text>
  <xsl:text>name = '</xsl:text><xsl:value-of select="name" /><xsl:text>', </xsl:text>
  <xsl:text>timezone = '</xsl:text><xsl:value-of select="timezone" /><xsl:text>', </xsl:text>
  <xsl:text>ip = '127.0.0.1'</xsl:text>
  <xsl:if test="supregion/id">
    <xsl:text>, masterid = </xsl:text><xsl:value-of select="supregion/id" />
  </xsl:if>
  <xsl:text> where nodeid = </xsl:text><xsl:value-of select="id" /><xsl:text>;
  </xsl:text>
</xsl:template>
<xsl:template name="add-item">
  <xsl:param name="type" />
  <xsl:param name="key" />
  <xsl:param name="delay" />
  <xsl:param name="value-type" />
  <xsl:param name="desc" />
  <xsl:param name="trappers" />
  <xsl:param name="units" />
  <xsl:param name="formula" />
  <xsl:param name="host" />
  <xsl:text>insert into items (itemid, type, snmp_community, snmp_oid, hostid, description, key_, delay, status, value_type, trapper_hosts, units, snmpv3_securityname, snmpv3_authpassphrase, snmpv3_privpassphrase, formula, error, logtimefmt, delay_flex, params, ipmi_sensor, username, password, publickey, privatekey) </xsl:text>
  <xsl:text>select coalesce(max(i.itemid), 0) + 1 as itemid, </xsl:text>
  <xsl:value-of select="$type" /><xsl:text> as type, </xsl:text>
  <xsl:text>'' as snmp_community, </xsl:text>
  <xsl:text>'' as snmp_oid, </xsl:text>
  <xsl:text>h.hostid as hostid, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$desc" /><xsl:text>' as description, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$key" /><xsl:text>' as key_, </xsl:text>
  <xsl:value-of select="$delay" /><xsl:text> as delay, </xsl:text>
  <xsl:text>0 as status, </xsl:text>
  <xsl:value-of select="$value-type" /><xsl:text> as value_type, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$trappers" /><xsl:text>' as trapper_hosts, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$units" /><xsl:text>' as units, </xsl:text>
  <xsl:text>'' as snmpv3_securityname, '' as snmpv3_authpassphrase, '' as snmpv3_privpassphrase, </xsl:text>
  <xsl:text>'' as formula, </xsl:text>
  <xsl:text>'' as error, '' as logtimefmt, '' as delay_flex, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$formula" /><xsl:text>' as params, </xsl:text>
  <xsl:text>'' as ipmi_sensor, '' as username, '' as password, '' as publickey, '' as privatekey </xsl:text>
  <xsl:text>from items i </xsl:text>
  <xsl:text>right join hosts h on 1 = 1 </xsl:text>
  <xsl:text>where h.host = '</xsl:text><xsl:value-of select="$host/name" /><xsl:text>';
</xsl:text>
</xsl:template>
<xsl:template name="add-calculated-item">
  <xsl:param name="key" />
  <xsl:param name="value-type" />
  <xsl:param name="host" />
  <xsl:param name="formula" />
  <xsl:param name="desc" />
  <xsl:call-template name="add-item">
    <xsl:with-param name="type" select="15" />
    <xsl:with-param name="key" select="$key" />
    <xsl:with-param name="delay" select="30" />
    <xsl:with-param name="value-type" select="$value-type" />
    <xsl:with-param name="desc" select="$desc" />
    <xsl:with-param name="trappers" select="'localhost'" />
    <xsl:with-param name="units" select="''" />
    <xsl:with-param name="formula" select="$formula" />
    <xsl:with-param name="host" select="$host" />
  </xsl:call-template>
</xsl:template>
<xsl:template name="add-node-item">
  <xsl:param name="node" select="." />
  <xsl:param name="key" select="'node.status'" />
  <xsl:param name="desc" select="'Node status'" />
  <xsl:call-template name="add-calculated-item">
    <xsl:with-param name="key" select="$key" />
    <xsl:with-param name="value-type" select="3" />
    <xsl:with-param name="host" select="$node" />
    <xsl:with-param name="formula"
		    select="0" />
    <xsl:with-param name="desc" select="$desc" />
  </xsl:call-template>
</xsl:template>
<xsl:template name="add-mirror-item">
  <xsl:param name="host" select="." />
  <xsl:param name="key" select="'node.status'" />
  <xsl:text>create temporary table items_copy </xsl:text>
  <xsl:text>select * from items where </xsl:text>
  <xsl:text>key_='</xsl:text><xsl:value-of select="$key" /><xsl:text>' </xsl:text>
  <xsl:text>and templateid = 0;
</xsl:text>
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:call-template name="inherit">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:call-template name="move-to-host">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:text>update items_copy i </xsl:text>
  <xsl:text>left join items_id_copy ii on i.itemid = ii.origid </xsl:text>
  <xsl:text>set i.itemid = ii.itemid, </xsl:text>
  <xsl:text>type = 15, </xsl:text>
  <xsl:text>params = concat('last("</xsl:text>
  <xsl:value-of select="name" /><xsl:text>:</xsl:text>
  <xsl:value-of select="name" /><xsl:text>:', key_, '")');
  </xsl:text>
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:call-template name="copy-applications" />
  <xsl:text>drop table items_id_copy;
</xsl:text>
</xsl:template>
<xsl:template name="get-itemid">
  <xsl:param name="host-name" />
  <xsl:param name="key" />
  <xsl:text>(select itemid from items </xsl:text>
  <xsl:text>where hostid = </xsl:text>
  <xsl:call-template name="get-hostid">
    <xsl:with-param name="name" select="$host-name" />
  </xsl:call-template><xsl:text> </xsl:text>
  <xsl:text>and key_ like '</xsl:text><xsl:value-of select="$key" />
  <xsl:text>')</xsl:text>
</xsl:template>
<xsl:template name="add-trigger">
  <xsl:param name="name" />
  <xsl:param name="key" />
  <xsl:param name="function" />
  <xsl:param name="conditional" select="'#0'" />
  <xsl:param name="priority" />
  <xsl:text>insert into triggers (triggerid, expression, description, url, status, value, priority, error) </xsl:text>
  <xsl:text>select coalesce(max(triggerid), 0) + 1 as triggerid, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$key" /><xsl:text>' as expression, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$name" /><xsl:text>' as description, </xsl:text>
  <xsl:text>'' as url, </xsl:text>
  <xsl:text>0 as status, </xsl:text>
  <xsl:text>2 as value, </xsl:text>
  <xsl:value-of select="$priority" /><xsl:text> as priority, </xsl:text>
  <xsl:text>'' as error </xsl:text>
  <xsl:text>from triggers;
</xsl:text>
  <xsl:text>insert into functions (functionid, itemid, triggerid, function) </xsl:text>
  <xsl:text>select coalesce(max(f.functionid), 0) + 1 as functionid, </xsl:text>
  <xsl:text>i.itemid as itemid, </xsl:text>
  <xsl:text>t.triggerid as triggerid, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$function" /><xsl:text>' as function </xsl:text>
  <xsl:text>from functions f </xsl:text>
  <xsl:text>right join items i on 1 = 1 </xsl:text>
  <xsl:text>right join hosts h on i.hostid = h.hostid </xsl:text>
  <xsl:text>right join triggers t on 1 = 1 </xsl:text>
  <xsl:text>where i.key_ = '</xsl:text><xsl:value-of select="$key" /><xsl:text>' </xsl:text>
  <xsl:text>and h.host = '</xsl:text><xsl:value-of select="name" /><xsl:text>' </xsl:text>
  <xsl:text>and t.expression = '</xsl:text><xsl:value-of select="$key" /><xsl:text>';
</xsl:text>
  <xsl:text>update triggers t, functions f, items i, hosts h </xsl:text>
  <xsl:text>set expression = concat('{', f.functionid, '}', </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$conditional" /><xsl:text>') </xsl:text>
  <xsl:text>where t.expression = '</xsl:text><xsl:value-of select="$key" /><xsl:text>' </xsl:text>
  <xsl:text>and f.triggerid = t.triggerid </xsl:text>
  <xsl:text>and f.itemid = i.itemid </xsl:text>
  <xsl:text>and i.key_ = t.expression </xsl:text>
  <xsl:text>and i.hostid = h.hostid </xsl:text>
  <xsl:text>and h.host ='</xsl:text><xsl:value-of select="name" /><xsl:text>';
</xsl:text>
</xsl:template>
<xsl:template name="add-trigger-to-link">
  <xsl:param name="map" />
  <xsl:param name="host-1" />
  <xsl:param name="host-2" />
  <xsl:param name="trigger" />
  <xsl:param name="item" />
  <xsl:text>insert into sysmaps_link_triggers </xsl:text>
  <xsl:text>select coalesce(max(mt.linktriggerid), 0) + 1 as linktriggerid, </xsl:text>
  <xsl:call-template name="get-linkid">
    <xsl:with-param name="map-name" select="$map/../name" />
    <xsl:with-param name="host-1-name" select="$host-1/name" />
    <xsl:with-param name="host-2-name" select="$host-2/name" />
  </xsl:call-template><xsl:text> as linkid, </xsl:text>
  <xsl:choose>
    <xsl:when test="$trigger">
      <xsl:call-template name="get-triggerid">
	<xsl:with-param name="name" select="$trigger" />
	<xsl:with-param name="host-name" select="$host-2/name" />
      </xsl:call-template>
    </xsl:when>
    <xsl:when test="$item">
      <xsl:call-template name="get-triggerid">
	<xsl:with-param name="item" select="$item" />
	<xsl:with-param name="host-name" select="$host-2/name" />
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
      <xsl:message terminate="yes">Specify trigger name or trigger base item key</xsl:message>
    </xsl:otherwise>
  </xsl:choose><xsl:text> as triggerid, </xsl:text>
  <xsl:text>4 as drawtype, </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$broken-link-color" /><xsl:text>' as color </xsl:text>
  <xsl:text>from sysmaps_link_triggers mt;
</xsl:text>
</xsl:template>
<xsl:template name="get-mapid">
  <xsl:param name="name" />
  <xsl:text>(select sysmapid from sysmaps where name = '</xsl:text>
  <xsl:value-of select="$name" /><xsl:text>')</xsl:text>
</xsl:template>
<xsl:template name="get-host-mapelementid">
  <xsl:param name="map-name" />
  <xsl:param name="host-name" />
  <xsl:text>(select selementid from sysmaps_elements </xsl:text>
  <xsl:text>where sysmapid = </xsl:text>
  <xsl:call-template name="get-mapid">
    <xsl:with-param name="name" select="$map-name" />
  </xsl:call-template><xsl:text> </xsl:text>
  <xsl:text>and elementid = </xsl:text>
  <xsl:call-template name="get-hostid">
    <xsl:with-param name="name" select="$host-name" />
  </xsl:call-template><xsl:text> </xsl:text>
  <xsl:text>and elementtype = 0)</xsl:text>
</xsl:template>
<xsl:template name="get-linkid">
  <xsl:param name="map-name" />
  <xsl:param name="host-1-name" />
  <xsl:param name="host-2-name" />
  <xsl:text>(select linkid from sysmaps_links </xsl:text>
  <xsl:text>where sysmapid = </xsl:text>
  <xsl:call-template name="get-mapid">
    <xsl:with-param name="name" select="$map-name" />
  </xsl:call-template><xsl:text> </xsl:text>
  <xsl:text>and selementid1 = </xsl:text>
  <xsl:call-template name="get-host-mapelementid">
    <xsl:with-param name="map-name" select="$map-name" />
    <xsl:with-param name="host-name" select="$host-1-name" />
  </xsl:call-template><xsl:text> </xsl:text>
  <xsl:text>and selementid2 = </xsl:text>
  <xsl:call-template name="get-host-mapelementid">
    <xsl:with-param name="map-name" select="$map-name" />
    <xsl:with-param name="host-name" select="$host-2-name" />
  </xsl:call-template><xsl:text>)</xsl:text>
</xsl:template>
<xsl:template name="get-items">
  <xsl:param name="host-name" select="name" />
  <xsl:text>(select itemid from items where hostid = </xsl:text>
  <xsl:call-template name="get-hostid">
    <xsl:with-param name="name" select="$host-name" />
  </xsl:call-template>
  <xsl:text>)</xsl:text>
</xsl:template>
<xsl:template name="get-triggerid">
  <xsl:param name="name" />
  <xsl:param name="item" />
  <xsl:param name="host-name" />
  <xsl:text>(select triggerid from triggers </xsl:text>
  <xsl:text>where </xsl:text>
  <xsl:choose>
    <xsl:when test="$name">
      <xsl:text>description = '</xsl:text>
      <xsl:value-of select="$name" /><xsl:text>'</xsl:text>
    </xsl:when>
    <xsl:when test="$item">
      <xsl:text>triggerid in </xsl:text>
      <xsl:text>(select triggerid from functions where itemid = </xsl:text>
      <xsl:call-template name="get-itemid">
	<xsl:with-param name="host-name" select="$host-name" />
	<xsl:with-param name="key" select="$item" />
      </xsl:call-template><xsl:text>)</xsl:text>
    </xsl:when>
    <xsl:otherwise>
      <xsl:message terminate="yes">Specify trigger name or trigger base item key</xsl:message>
    </xsl:otherwise>
  </xsl:choose><xsl:text> </xsl:text>
  <xsl:text>and triggerid in </xsl:text>
  <xsl:text>(select triggerid from functions where itemid in </xsl:text>
  <xsl:call-template name="get-items">
    <xsl:with-param name="host-name" select="$host-name" />
  </xsl:call-template><xsl:text>))</xsl:text>
</xsl:template>
<xsl:template name="link-template">
  <xsl:param name="template-name" />
  <xsl:text>insert into hosts_templates </xsl:text>
  <xsl:text>select coalesce(max(ht.hosttemplateid), 0) + 1 as hosttemplateid, </xsl:text>
  <xsl:text>h1.hostid as hostid, </xsl:text>
  <xsl:text>h2.hostid as templateid </xsl:text>
  <xsl:text>from hosts_templates ht </xsl:text>
  <xsl:text>right join hosts h1 on 1 = 1 </xsl:text>
  <xsl:text>right join hosts h2 on 1 = 1 </xsl:text>
  <xsl:text>where h1.host = '</xsl:text><xsl:value-of select="name" /><xsl:text>' </xsl:text>
  <xsl:text>and h2.host = '</xsl:text><xsl:value-of select="$template-name" /><xsl:text>';
</xsl:text>
  <xsl:call-template name="copy-items">
    <xsl:with-param name="template-name" select="$template-name" />
  </xsl:call-template>
</xsl:template>
<xsl:template name="copy-items">
  <xsl:param name="template-name" />
  <xsl:text>create temporary table items_copy </xsl:text>
  <xsl:text>select * from items </xsl:text>
  <xsl:text>where hostid = </xsl:text>
  <xsl:call-template name="get-hostid">
    <xsl:with-param name="name" select="$template-name" />
  </xsl:call-template>
  <xsl:text>;
</xsl:text>
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:call-template name="inherit">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:text>update items_copy c left join items_id_copy ci on ci.origid = c.itemid </xsl:text>
  <xsl:text>set c.itemid = ci.itemid;
</xsl:text>
  <xsl:call-template name="move-to-host">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'item'" />
  </xsl:call-template>
  <xsl:call-template name="copy-by-items">
    <xsl:with-param name="base-name" select="'function'" />
  </xsl:call-template>
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'function'" />
  </xsl:call-template>
  <xsl:text>create temporary table triggers_copy </xsl:text>
  <xsl:text>select * from triggers </xsl:text>
  <xsl:text>where triggerid in (select triggerid from functions_copy);
</xsl:text>
  <xsl:call-template name="inherit">
    <xsl:with-param name="base-name" select="'trigger'" />
  </xsl:call-template>
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'trigger'" />
  </xsl:call-template>
  <xsl:text>update functions_copy f left join functions_id_copy fi on fi.origid = f.functionid </xsl:text>
  <xsl:text>left join items_id_copy ii on ii.origid = f.itemid </xsl:text>
  <xsl:text>left join triggers_id_copy ti on ti.origid = f.triggerid </xsl:text>
  <xsl:text>left join triggers_copy t on t.triggerid = f.triggerid </xsl:text>
  <xsl:text>set f.functionid = fi.functionid, </xsl:text>
  <xsl:text>f.itemid = ii.itemid, </xsl:text>
  <xsl:text>f.triggerid = ti.triggerid, </xsl:text>
  <xsl:text>t.triggerid = ti.triggerid;
</xsl:text>
  <xsl:call-template name="update-trigger-expressions" />
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'trigger'" />
  </xsl:call-template>
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'function'" />
  </xsl:call-template>
  <xsl:text>drop table functions_id_copy;
</xsl:text>
  <xsl:text>create table triggers_id_copy2 select * from triggers_id_copy;
</xsl:text>
  <xsl:text>insert into trigger_depends </xsl:text>
  <xsl:text>select (@id:=@id + 1) as triggerdepid, </xsl:text>
  <xsl:text>ti2.triggerid as triggerid_up, </xsl:text>
  <xsl:text>ti1.triggerid as triggerid_down </xsl:text>
  <xsl:text>from (select (@id:=coalesce(max(triggerdepid), 0)) from trigger_depends) r, </xsl:text>
  <xsl:text>triggers_id_copy ti1 cross join trigger_depends td on td.triggerid_up = ti1.origid </xsl:text>
  <xsl:text>left join triggers_id_copy2 ti2 on td.triggerid_down = ti2.origid;
</xsl:text>
  <xsl:text>drop table triggers_id_copy2;
</xsl:text>
  <xsl:text>drop table triggers_id_copy;
</xsl:text>
  <xsl:call-template name="copy-applications" />
  <xsl:call-template name="copy-by-items">
    <xsl:with-param name="base-name" select="'gitem'" />
    <xsl:with-param name="table-name" select="'graphs_items'" />
  </xsl:call-template>
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'gitem'" />
    <xsl:with-param name="table-name" select="'graphs_items'" />
  </xsl:call-template>
  <xsl:text>create temporary table graphs_copy </xsl:text>
  <xsl:text>select * from graphs </xsl:text>
  <xsl:text>where graphid in (select graphid from gitems_copy);
</xsl:text>
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'graph'" />
  </xsl:call-template>
  <xsl:call-template name="inherit">
    <xsl:with-param name="base-name" select="'graph'" />
  </xsl:call-template>
  <xsl:text>update graphs_copy g left join graphs_id_copy gi on gi.origid = g.graphid </xsl:text>
  <xsl:text>right join gitems_copy ig on ig.graphid = g.graphid </xsl:text>
  <xsl:text>left join gitems_id_copy igi on igi.origid = ig.gitemid </xsl:text>
  <xsl:text>left join items_id_copy ii on ii.origid = ig.itemid </xsl:text>
  <xsl:text>set g.graphid = gi.graphid, </xsl:text>
  <xsl:text>ig.gitemid = igi.gitemid, </xsl:text>
  <xsl:text>ig.graphid = gi.graphid, </xsl:text>
  <xsl:text>ig.itemid = ii.itemid;
</xsl:text>
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'graph'" />
  </xsl:call-template>
  <xsl:text>drop table graphs_id_copy;
</xsl:text>
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'gitem'" />
    <xsl:with-param name="table-name" select="'graphs_items'" />
  </xsl:call-template>
  <xsl:text>drop table gitems_id_copy;
</xsl:text>
  <xsl:text>drop table items_id_copy;
</xsl:text>
</xsl:template>
<xsl:template name="get-hostid">
  <xsl:param name="name" select="name" />
  <xsl:text>(select hostid from hosts where host = '</xsl:text><xsl:value-of select="$name" /><xsl:text>')</xsl:text>
</xsl:template>
<xsl:template name="create-id-copy-table">
  <xsl:param name="base-name" />
  <xsl:param name="id-name" select="concat($base-name, 'id')" />
  <xsl:param name="table-name" select="concat($base-name, 's')" />
  <xsl:text>create temporary table </xsl:text><xsl:value-of select="$base-name" /><xsl:text>s_id_copy </xsl:text>
  <xsl:text>select </xsl:text><xsl:value-of select="$id-name" /><xsl:text> as origid, </xsl:text>
  <xsl:text>(@id:=@id + 1) as </xsl:text><xsl:value-of select="$id-name" /><xsl:text> </xsl:text>
  <xsl:text>from </xsl:text><xsl:value-of select="$base-name" /><xsl:text>s_copy c, </xsl:text>
  <xsl:text>(select @id:=coalesce(max(</xsl:text><xsl:value-of select="$id-name" /><xsl:text>), 0) </xsl:text>
  <xsl:text>from </xsl:text><xsl:value-of select="$table-name" /><xsl:text>) r;
</xsl:text>
</xsl:template>
<xsl:template name="inherit">
  <xsl:param name="base-name" />
  <xsl:param name="id-field"  select="concat($base-name, 'id')" />
  <xsl:param name="templateid-field" select="'templateid'" />
  <xsl:text>update </xsl:text><xsl:value-of select="$base-name" /><xsl:text>s_copy </xsl:text>
  <xsl:text>set </xsl:text><xsl:value-of select="$templateid-field" /><xsl:text> = </xsl:text>
  <xsl:value-of select="$id-field" /><xsl:text>;
</xsl:text>
</xsl:template>
<xsl:template name="move-to-host">
  <xsl:param name="base-name" />
  <xsl:param name="hostid-field" select="'hostid'" />
  <xsl:text>update </xsl:text><xsl:value-of select="$base-name" /><xsl:text>s_copy </xsl:text>
  <xsl:text>set </xsl:text><xsl:value-of select="$hostid-field" /><xsl:text> = </xsl:text>
  <xsl:call-template name="get-hostid">
    <xsl:with-param name="name" select="name" />
  </xsl:call-template>
  <xsl:text>;
</xsl:text>
</xsl:template>
<xsl:template name="insert-and-drop">
  <xsl:param name="base-name" />
  <xsl:param name="table-name" select="concat($base-name, 's')" />
  <xsl:param name="action" select="'insert into'" />
  <xsl:value-of select="$action" /><xsl:text> </xsl:text>
  <xsl:value-of select="$table-name" /><xsl:text> </xsl:text>
  <xsl:text>select * from </xsl:text><xsl:value-of select="$base-name" /><xsl:text>s_copy;
</xsl:text>
  <xsl:text>drop table </xsl:text><xsl:value-of select="$base-name" /><xsl:text>s_copy;
</xsl:text>
</xsl:template>
<xsl:template name="copy-by-items">
  <xsl:param name="base-name" />
  <xsl:param name="table-name" select="concat($base-name, 's')" />
  <xsl:param name="itemid-field" select="'itemid'" />
  <xsl:param name="items-idcopy-name" select="'items_id_copy'" />
  <xsl:text>create temporary table </xsl:text><xsl:value-of select="$base-name" /><xsl:text>s_copy </xsl:text>
  <xsl:text>select * from </xsl:text><xsl:value-of select="$table-name" /><xsl:text> </xsl:text>
  <xsl:text>where </xsl:text><xsl:value-of select="$itemid-field" /><xsl:text> in </xsl:text>
  <xsl:text>(select origid from </xsl:text><xsl:value-of select="$items-idcopy-name" /><xsl:text>);
</xsl:text>
</xsl:template>
<xsl:template name="add-user">
  <xsl:param name="dbname" select="'$dbname'" />
  <xsl:param name="dbuser" select="'$dbuser'" />
  <xsl:param name="hostname" select="'localhost'" />
  <xsl:param name="dbpass" select="'$dbpass'" />
  <xsl:text>grant all </xsl:text>
  <xsl:text>on </xsl:text>
  <xsl:value-of select="$dbname" /><xsl:text>.* to </xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$dbuser" /><xsl:text>'</xsl:text>
  <xsl:text>@</xsl:text>
  <xsl:text>'</xsl:text><xsl:value-of select="$hostname" /><xsl:text>' </xsl:text>
  <xsl:text>identified by '</xsl:text>
  <xsl:value-of select="$dbpass" /><xsl:text>';
</xsl:text>
</xsl:template>
<xsl:template name="reset-db">
  <xsl:param name="dbname" select="'$dbname'" />
  <xsl:param name="dbuser" select="'$dbuser'" />
  <xsl:param name="hostname" />
  <xsl:param name="dbpass" select="'$dbpass'" />
  <xsl:text>drop database if exists </xsl:text>
  <xsl:value-of select="$dbname" /><xsl:text>;
</xsl:text>
  <xsl:text>create database </xsl:text>
  <xsl:value-of select="$dbname" /><xsl:text> default charset 'utf8';
</xsl:text>
  <xsl:call-template name="add-user">
    <xsl:with-param name="dbname" select="$dbname" />
    <xsl:with-param name="dbuser" select="$dbuser" />
    <xsl:with-param name="hostname" select="'localhost'" />
    <xsl:with-param name="dbpass" select="$dbpass" />
  </xsl:call-template>
  <xsl:if test="$hostname">
    <xsl:call-template name="add-user">
      <xsl:with-param name="dbname" select="$dbname" />
      <xsl:with-param name="dbuser" select="$dbuser" />
      <xsl:with-param name="hostname" select="$hostname" />
      <xsl:with-param name="dbpass" select="$dbpass" />
    </xsl:call-template>
  </xsl:if>
</xsl:template>
<xsl:template name="select-db">
  <xsl:param name="dbname" select="'$dbname'" />
  <xsl:text>use </xsl:text><xsl:value-of select="$dbname" /><xsl:text>;
</xsl:text>
</xsl:template>
<xsl:template name="declare-objects">
  <xsl:text>delimiter //
</xsl:text>
  <xsl:text>create procedure update_triggers() begin declare done int default 0; declare o,i int; declare id_cur cursor for select origid, functionid from functions_id_copy; declare continue handler for not found set done = 1; open id_cur; read_loop: loop fetch id_cur into o, i; if done then leave read_loop; end if; update triggers_copy set expression = replace(expression, concat('{', o, '}'), concat('{', i, '}')); end loop; close id_cur; end//
</xsl:text>
  <xsl:text>delimiter ;
</xsl:text>
</xsl:template>
<xsl:template name="undeclare-objects">
  <xsl:text>drop procedure update_triggers;
</xsl:text>
</xsl:template>
<xsl:template name="update-trigger-expressions">
  <xsl:text>call update_triggers();
</xsl:text>
</xsl:template>
<xsl:template name="copy-applications">
  <xsl:call-template name="copy-by-items">
    <xsl:with-param name="base-name" select="'itemapp'" />
    <xsl:with-param name="table-name" select="'items_applications'" />
  </xsl:call-template>
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'itemapp'" />
    <xsl:with-param name="table-name" select="'items_applications'" />
  </xsl:call-template>
  <xsl:text>create temporary table applications_copy </xsl:text>
  <xsl:text>select * from applications </xsl:text>
  <xsl:text>where applicationid in </xsl:text>
  <xsl:text>(select applicationid from itemapps_copy);</xsl:text>
  <!--xsl:text>and name not in </xsl:text>
  <xsl:text>(select name from applications </xsl:text>
  <xsl:text>where hostid = </xsl:text>
  <xsl:call-template name="get-hostid" />
  <xsl:text>);
</xsl:text-->
  <!--xsl:text>delete from itemapps_copy </xsl:text>
  <xsl:text>where applicationid not in </xsl:text>
  <xsl:text>(select applicationid from applications_copy);
</xsl:text-->
  <xsl:call-template name="create-id-copy-table">
    <xsl:with-param name="base-name" select="'application'" />
  </xsl:call-template>
  <xsl:call-template name="inherit">
    <xsl:with-param name="base-name" select="'application'" />
  </xsl:call-template>
  <xsl:call-template name="move-to-host">
    <xsl:with-param name="base-name" select="'application'" />
  </xsl:call-template>
  <xsl:text>update applications_id_copy aic </xsl:text>
  <xsl:text>left join applications_copy ac on ac.applicationid = aic.origid </xsl:text>
  <xsl:text>left join applications a on ac.name = a.name and a.hostid = ac.hostid </xsl:text>
  <xsl:text>set aic.applicationid = a.applicationid, </xsl:text>
  <xsl:text>ac.templateid = a.templateid </xsl:text>
  <xsl:text>where a.applicationid is not null;
</xsl:text>
  <xsl:text>update applications_copy a </xsl:text>
  <xsl:text>left join applications_id_copy ai on ai.origid = a.applicationid </xsl:text>
  <xsl:text>right join itemapps_copy ia on ia.applicationid = a.applicationid </xsl:text>
  <xsl:text>left join itemapps_id_copy iai on iai.origid = ia.itemappid </xsl:text>
  <xsl:text>left join items_id_copy ii on ii.origid = ia.itemid </xsl:text>
  <xsl:text>set a.applicationid = ai.applicationid, </xsl:text>
  <xsl:text>ia.itemappid = iai.itemappid, </xsl:text>
  <xsl:text>ia.itemid = ii.itemid, </xsl:text>
  <xsl:text>ia.applicationid = ai.applicationid;
</xsl:text>
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'application'" />
    <xsl:with-param name="action" select="'replace'" />
  </xsl:call-template>
  <xsl:call-template name="insert-and-drop">
    <xsl:with-param name="base-name" select="'itemapp'" />
    <xsl:with-param name="table-name" select="'items_applications'" />
  </xsl:call-template>
  <xsl:text>drop table applications_id_copy;
</xsl:text>
  <xsl:text>drop table itemapps_id_copy;
</xsl:text>
</xsl:template>
<xsl:template name="update-ids">
  <xsl:param name="fieldname" />
  <xsl:param name="tablename" />
  <xsl:text>update ids set </xsl:text>
  <xsl:text>nextid = (select coalesce(max(</xsl:text><xsl:value-of select="$fieldname" /><xsl:text>), 0) + 1 as </xsl:text><xsl:value-of select="$fieldname" /><xsl:text> from </xsl:text><xsl:value-of select="$tablename" /><xsl:text>)</xsl:text>
  <xsl:text> where table_name = '</xsl:text><xsl:value-of select="$tablename" /><xsl:text>' and field_name = '</xsl:text><xsl:value-of select="$fieldname" /><xsl:text>';
</xsl:text>
</xsl:template>
<xsl:template name="update-all-ids">
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'actions'" />
    <xsl:with-param name="fieldname" select="'actionid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'applications'" />
    <xsl:with-param name="fieldname" select="'applicationid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'auditlog'" />
    <xsl:with-param name="fieldname" select="'auditid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'events'" />
    <xsl:with-param name="fieldname" select="'eventid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'functions'" />
    <xsl:with-param name="fieldname" select="'functionid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'hostmacro'" />
    <xsl:with-param name="fieldname" select="'hostmacroid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'hosts'" />
    <xsl:with-param name="fieldname" select="'hostid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'hosts_groups'" />
    <xsl:with-param name="fieldname" select="'hostgroupid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'hosts_templates'" />
    <xsl:with-param name="fieldname" select="'hosttemplateid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'housekeeper'" />
    <xsl:with-param name="fieldname" select="'housekeeperid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'items'" />
    <xsl:with-param name="fieldname" select="'itemid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'items_applications'" />
    <xsl:with-param name="fieldname" select="'itemappid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'operations'" />
    <xsl:with-param name="fieldname" select="'operationid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'profiles'" />
    <xsl:with-param name="fieldname" select="'profileid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'triggers'" />
    <xsl:with-param name="fieldname" select="'triggerid'" />
  </xsl:call-template>
  <xsl:call-template name="update-ids">
    <xsl:with-param name="tablename" select="'user_history'" />
    <xsl:with-param name="fieldname" select="'userhistoryid'" />
  </xsl:call-template>
</xsl:template>
</xsl:stylesheet>
